<?php

namespace yifang\exception;

use yifang\lib\Exception;

/**
 * 错误异常
 */
class ErrorException extends Exception
{
    /**
     * 用于保存错误级别
     */
    protected $severity;

    /**
     * 错误异常构造函数
     * @param  integer $severity 错误级别
     * @param  string  $message  错误详细信息
     * @param  string  $file     出错文件路径
     * @param  integer $line     出错行号
     */
    public function __construct($severity, $message, $file, $line)
    {
        $this->severity = $severity;
        $this->message  = $message;
        $this->file     = $file;
        $this->line     = $line;
        $this->code     = 0;
    }

    /**
     * 获取错误级别
     */
    final public function getSeverity()
    {
        return $this->severity;
    }
}
