<?php

namespace yifang\model;


/**
 * 多对多中间表模型类
 */
class Pivot extends Model
{

    /**
     * 父模型
     * @var Model
     */
    public $parent;

    /**
     * 是否时间自动写入
     * @var bool
     */
    protected $autoWriteTimestamp = false;

    /**
     * 架构函数
     */
    public function __construct(array $data = [], Model $parent = null, $table = '')
    {
        $this->parent = $parent;
        if (is_null($this->name)) {
            $this->name = $table;
        }
        parent::__construct($data);
    }

    /**
     * 创建新的模型实例
     * @return Model
     */
    public function newInstance(array $data = [], $where = null, array $options = [])
    {
        $model = parent::newInstance($data, $where, $options);
        $model->parent = $this->parent;
        $model->name   = $this->name;
        return $model;
    }
}
